program wheel;
{The wheel of fortune game for the IBM-PC.  Based on the popular TV Game
 show.  Program written and conceived by Jason Marks, Portland, OR, with
 the help of Joanne Hossack.

 January 1, 1986, update 4/86}

const vowelPrice = 250;

type phraseType =  record
                    phrase: string[80];
                    category: string[20];
     end;
     playerType = record
                  name: string[10];
                  cash, roundScore: integer;
     end;

var entry: phrasetype;
    hiddenPhrase: string[80];
    value: string[9];
    player: array [1..3] of playerType;
    guessed,playAgain: boolean;
    i,line1,n_players,current,round: integer;

function semirandom(maxnum: integer): integer;
var  rset: record
             AX,BX,CX,DX,BP,SI,DI,DS,ES,Flags: integer;
           end;
     multiplier: real;

begin
 rset.AX:=$2C00;
 MSDOS(Rset);
 MemW[Dseg:$129]:=rset.CX;
 MemW[Dseg:$12B]:=rset.DX;

 multiplier := rset.DX/15210;
 semirandom := trunc(multiplier * maxnum);
end;


procedure spinWheel;            {spin the wheel of fortune}
var i: integer;

begin
normVideo;
for i:=1 to 20 do
  begin
    delay(i*i);
    case random(100) of
      0 .. 5: value:= 'Bankrupt ';
      6 .. 11: value:= 'Lose Turn';
      12 .. 17: value:= '200      ';
      18 .. 25: value:= '250      ';
      26 .. 30: value:= '450      ';
      31 .. 45: value:= '300      ';
      46 .. 60: value:= '400      ';
      61 .. 75: value:= '500      ';
      76 .. 90: value:= '600      ';
      91 .. 99: value:= '700      ';
    end;

    GotoXY(18,22);
    write(value);
    sound(1000);
    nosound;
  end;
  lowVideo;
  GotoXY(1,10);                        {restore cursorposition}
end;

procedure readPhrase;

var listfile: file of phrasetype;
    recno,check: integer;

begin
  assign(listfile,'wheel.txt');
  reset(listfile);

  with entry do
  begin
     read(listfile,entry);                    {new code section}
     val(phrase,recno,check);
     if check >0 then
        recno := 0;
     if recno+1 >= filesize(listfile) then
        recno := 0;
     str(recno+1,phrase);
     seek(listfile,0);
     write(listfile,entry);
     seek(listfile,recno);
     read(listfile,entry);

     hiddenPhrase := phrase;            {initialize hidden phrase}
     for i:=1 to length(phrase) do
         if phrase[i] in ['A'..'Z'] then
            hiddenPhrase[i] := #254
         else
             hiddenPhrase[i] := phrase[i];

         line1 := 40;                   {break-point if line too long}
         repeat line1 := (line1 -1)
            until phrase[line1] = ' ';
  end;
  close(listfile);

end;

Procedure updateScreen;
begin
    GotoXY(1,6);
    normvideo;
    if length(hiddenPhrase) <= 40 then
       writeln(hiddenPhrase)
    else
       begin
          writeln(Copy(hiddenPhrase,1,line1));
          writeln(Copy(hiddenPhrase,line1+1,80));
       end;
    lowVideo;
    for i := 1 to n_players do
     begin
       if i= current then normvideo;
       window(i*10,16,40,25);
       GotoXY(1,1);
       writeln(player[i].name);
       writeln(player[i].roundScore,'   ');
       writeln;
       writeln(player[i].cash);
       lowvideo;
     end;
     window(1,1,40,25);
     GotoXY(1,10);
     clrEol;
end;


Procedure getChoice;

var ch: char;
    guess: string[80];
    points,convCode: integer;

begin
  repeat Read(Kbd,ch)
    until (ch = #27) and Keypressed;
  read(Kbd,ch);

  playAgain := false;                        {pick correct letter -> true}
  with player[current] do
   begin
     case ch of
       #59: begin   {Choose a letter}
           SpinWheel;
           val(copy(value,1,3),points,convCode);
           if ConvCode = 0 then
             begin
               Write('Please enter a letter > ');
                 repeat read(Kbd,ch)
                   until (ch in ['A'..'Z']) and not (ch in ['A','E','I','O','U']);
                 write(ch);
                 delay(1500);
                 for i:= 1 to length(entry.phrase) do
                   if (entry.phrase[i] = ch) and (hiddenphrase[i] <> ch) then
                     begin                     {can't pick same letter twice}
                       hiddenPhrase[i] := ch;
                       roundScore := roundScore +points;
                       playAgain := true;
                       sound(1500);delay(100);nosound;sound(2300);delay(100);nosound;delay(200);
                      end;
               end
             else if value = 'Bankrupt ' then
               roundScore := 0;
               {else if lose turn - do nothing}
         end;

         #61: begin   {Buy Vowel}
           if roundScore < vowelPrice then
             begin
               writeln('Insufficient funds to buy vowel....');
               write('...Press <RETURN> to continue');
               readln;
               GotoXY(1,11);
               ClrEol;
               playAgain := True;
              end
            else
              begin
                 roundScore := roundScore - vowelPrice;
                 Write('Please enter a vowel > ');
                 repeat read(Kbd,ch)
                    until ch in ['A','E','I','O','U'];
                 write(ch);
                 delay(1500);
                 for i:= 1 to length(entry.phrase) do
                   if entry.phrase[i] = ch then
                     begin
                       hiddenPhrase[i] := ch;
                       playAgain := True;
                       sound(1500);delay(100);nosound;sound(2300);delay(100);nosound;delay(200);
                     end;
               end
             end;
          #63: begin    {guess}
             Writeln('Please enter your guess at the phrase');
             readln(guess);
             if (guess = entry.phrase) then
               begin
                 writeln(name,' has guessed correctly!!');
                 cash := cash + roundScore;
                 guessed := true;
                 write('Press <RETURN> to continue...');
                 readln;
                end
             else
               begin
                 gotoXY(1,10);
                 writeln(#7'Incorrect...press <RETURN> to continue');
                 read;
                 ClrEol;
             end;
            end;
          else Writeln(#7'Invalid Choice');
      end;                                 {end case}
  end;                                     {end with player do}

  if not playAgain then
   begin
    current := current +1;
    sound(300);delay(300);nosound;
   end;
  if current > n_players then current := 1;
end;


{main program}
begin
     textmode(BW40);
     lowVideo;
     writeln('Welcome to the Wheel of Fortune');
     writeln;
     writeln('Please Press Caps Lock');
     writeln;
     Write('How many players (1-3) > ');
     repeat read(n_players)
       until n_players in [1..3];
     for i:=1 to n_players do
       begin
         writeln;
         write('Name Player #',i,'> ');
         readln(player[i].name);
         player[i].cash := 0;
       end;

     for round := 1 to 3 do
       begin
         readPhrase;
         guessed := false;
         current := round;                 {initialize whose turn}
         if current > n_players then
           current := 1;
         for i:=1 to n_players do
            player[i].roundScore := 0;
         clrScr;                    {initialize screen}
         lowVideo;
         gotoxy(10,1);
         writeln('Wheel of Fortune');
         writeln;
         write('Category: ',entry.category,'    Round ',round);
         GotoXY(1,16);
         writeln('Player');
         writeln('Score');
         writeln;
         writeln('Cash');
         GotoXY(1,24);
         writeln('F1 - SPIN THE WHEEL   F3 - BUY VOWEL');
         write('   F5 - GUESS THE PHRASE');

         repeat
           updateScreen;
           getchoice;
         until guessed;
        end;
   ClrScr;
   for i:=1 to n_players do
       writeln(player[i].name,' Total Cash: $',player[i].cash);
   Writeln;
   Writeln('Thanks for playing,');
   writeln('Vanna White will assist you with         your prizes!');
   delay(8000);
   textMode(BW80);
end.
